<%@LANGUAGE="VBSCRIPT" CodePage=65001%>
<% option explicit %>
<!--#include file="adovbs.inc" -->
<!--#include file="connection.inc" -->
<%

	Dim saveUpdatePacket, aspdebug
	' For debug
	saveUpdatePacket = False

	aspdebug = request.querystring("debug")

	' ----- DB Connection -----
	' use DB_connection declared in connection.inc
	Dim objConn
	Set objConn = Server.CreateObject("ADODB.Connection")
	objConn.Open DB_connection

	' ----- Define Result Doc: UpdatePacket -----
  	Dim resultdoc
  	Set resultdoc = Server.CreateObject("Microsoft.XMLDOM")
  	resultdoc.async = False
    resultdoc.loadXML( "<?xml version=""1.0"" encoding=""UTF-8"" ?><update_packet></update_packet>")


	' ----- Read XML -----
  	Dim xmldoc
  	Set xmldoc = Server.CreateObject("Microsoft.XMLDOM")
  	xmldoc.async = False

   	If aspdebug = "1" Then
   		xmldoc.load(Server.MapPath("updatePacket.xml"))
   	Else
   		If Request.TotalBytes = 0 Then
			    xmldoc.loadXML( "<?xml version=""1.0"" encoding=""UTF-8"" ?><update_packet tableName=""TEST"" nullValue=""{_NULL_}"" transID=""""></update_packet>")
		Else
   			xmldoc.load Request
   		End If
   		If saveUpdatePacket Then
			xmldoc.save(Server.MapPath("updatePacket.xml"))
   		End If
	End If

	' ----- Parse UpdatePacket -----
	Dim rootNode, table, nullValue, transID
	Set rootNode = xmldoc.documentElement
	table = rootNode.getAttribute("tableName")
	' -- nullValue --
	nullValue = rootNode.getAttribute("nullValue")
	If Instr(nullValue, "{") = 1 And Instr(nullValue, "}") = Len(nullValue) Then
		nullValue = Mid(nullValue, 2, Len(nullValue)-2)
	End If
	transID = rootNode.getAttribute("transID")

	' ----- Prepare resultDoc -----
	Dim resultRootNode
	Set resultRootNode = xmldoc.createElement("update_packet")
	Set resultdoc.documentElement = resultRootNode
	resultRootNode.setAttribute "transID", transID

	' ----- process "update" nodes -----
	Dim nodes, node, fields, field
	Dim kname, ktype, kvalue, stmt
	Dim fname, ftype, fvalue
	Dim objRS, strSQL, newId
	Dim operationId

	Dim sqlError
	Dim roperationNode, rfieldNode
	Dim errorMsg
	Dim bValue, dValue

	Set nodes = rootNode.getElementsByTagName("update")
	For Each node In nodes
		sqlError = False
		operationId = node.getAttribute("id")
		Set fields = node.getElementsByTagName("field")
		' -- find key --
		For Each field in fields
			If field.getAttribute("key") = "true" Then
				kname = field.getAttribute("name")
				ktype = field.getAttribute("type")
				kvalue = field.getAttribute("oldValue")
				stmt = kvalue
				If ktype = "Integer" Or ktype = "Number" Then
					stmt = kname & "=" & kvalue
				Else
					kvalue = Replace(kvalue, "'", "''")
					stmt = kname & "= """ & kvalue & """"
				End If
				Exit For
			End If
		Next

    	strSQL = "SELECT * FROM " & table & " WHERE " & stmt
		Set objRS = Server.CreateObject("ADODB.RecordSet")
		On Error Resume Next
		objRS.Open strSQL, objConn, adOpenKeySet, adLockPessimistic
		If Err.Number <> 0 Then
			errorMsg = "" & Err.Description & " (" & fname & "-" & Err.Number & ") SQL_ISSUED: UPDATE"
			Err.Clear
			GenerateError errorMsg, "update"
			sqlError = True
		End If
		On Error Goto 0
		If Not sqlError Then
			If objRS.EOF Then
				' Cas record supprim
				errorMsg = "" & "Id not found () SQL_ISSUED: " & strSQL
				GenerateError errorMsg, "update"
			Else
				' -- update record --
				For Each field in fields
					If field.getAttribute("key") = "false" Then
						fname  = field.getAttribute("name")
						ftype  = field.getAttribute("type")
						fvalue = field.getAttribute("newValue")

						' -- check field name: transform [field] in field --
						If Instr(fname, "[") = 1 And Instr(fname, "]") = Len(fname) Then
							fname = Mid(fname, 2, Len(fname)-2)
						End If

						' -- check NullValue --
						If fvalue = nullValue Then
							fvalue = Null
						End If
						' -- check Boolean Value --
						If ftype = "Boolean" Then
							fvalue = CheckBooleanValue(fvalue)
						End If
						' -- check Date Value --
						If ftype = "Date" Then
							If Instr(fvalue, "#") = 1 And Instr(2, fvalue, "#") = Len(fvalue) Then
								dValue = fvalue
								fvalue = Mid(dValue, 2, Len(dValue)-2)
							End If
						End If
						On Error Resume Next
						objRS.Fields(fname) = fvalue
						If Err.Number <> 0 Then
							errorMsg = "" & Err.Description & " (" & fname & "-" & Err.Number & ") SQL_ISSUED: UPDATE"
							Err.Clear
							GenerateError errorMsg, "update"
							sqlError = True
							Exit For
						End If
						On Error Goto 0
					End If
				Next
				If Not sqlError Then
					On Error Resume Next
					objRS.Update
					If Err.Number <> 0 Then
						errorMsg = "" & Err.Description & " (" & Err.Number & ") SQL_ISSUED: UPDATE"
						Err.Clear
						GenerateError errorMsg, "update"
						sqlError = True
					End If
					On Error Goto 0
				End If
			End If
			objRS.Close
			Set objRS = Nothing
		End If

	Next

	' ----- process "delete" nodes -----
	Set nodes = rootNode.getElementsByTagName("delete")
	For Each node In nodes
		operationId = node.getAttribute("id")
		Set fields = node.getElementsByTagName("field")
		' -- find key --
		For Each field in fields
			If field.getAttribute("key") = "true" Then
				kname = field.getAttribute("name")
				ktype = field.getAttribute("type")
				kvalue = field.getAttribute("oldValue")
				stmt = kvalue
				If ktype = "Integer" Or ktype = "Number" Then
					stmt = kname & "=" & kvalue
				Else
					kvalue = Replace(kvalue, "'", "''")
					stmt = kname & "= """ & kvalue & """"
				End If
				Exit For
			End If
		Next

    	strSQL = "DELETE  FROM " & table & " WHERE " & stmt
    	On Error Resume Next
    	objConn.Execute(strSQL)
		If Err.Number <> 0 Then
			errorMsg = "" & Err.Description & " (" & Err.Number & ") SQL_ISSUED: " &  strSQL
			Err.Clear
			GenerateError errorMsg, "delete"
		End If
    Next

	' ----- process "insert" nodes -----
	Set nodes = rootNode.getElementsByTagName("insert")
	For Each node In nodes
		sqlError = False
		operationId = node.getAttribute("id")
		Set fields = node.getElementsByTagName("field")
		' -- find key --
		For Each field in fields
			If field.getAttribute("key") = "true" Then
				kname = field.getAttribute("name")
				ktype = field.getAttribute("type")
				Exit For
			End If
		Next

		Set objRS = Server.CreateObject("ADODB.RecordSet")
		On Error Resume Next
		objRS.Open table, objConn, adOpenKeySet, adLockPessimistic, adCmdTable
		If Err.Number <> 0 Then
			errorMsg = "" & Err.Description & " (" & fname & "-" & Err.Number & ") SQL_ISSUED: INSERT"
			Err.Clear
			GenerateError errorMsg, "insert"
			sqlError = True
		End If
		On Error Goto 0
		If Not sqlError Then
			objRS.AddNew
			' -- insert record --
			For Each field in fields
				If field.getAttribute("key") = "false" Then
					fname  = field.getAttribute("name")
					ftype  = field.getAttribute("type")
					fvalue = field.getAttribute("newValue")

					' -- check field name: transform [field] in field --
					If Instr(fname, "[") = 1 And Instr(fname, "]") = Len(fname) Then
						fname = Mid(fname, 2, Len(fname)-2)
					End If

					' -- check NullValue --
					If fvalue = nullValue Then
						fvalue = Null
					End If
					' -- check Boolean Value --
					If ftype = "Boolean" Then
						fvalue = CheckBooleanValue(fvalue)
					End If
					' -- check Date Value --
					If ftype = "Date" Then
						If Instr(fvalue, "#") = 1 And Instr(2, fvalue, "#") = Len(fvalue) Then
							dValue = fvalue
							fvalue = Mid(dValue, 2, Len(dValue)-2)
						End If
					End If
					On Error Resume Next
					objRS.Fields(fname) = fvalue
					If Err.Number <> 0 Then
						errorMsg = "" & Err.Description & " (" & fname & "-" & Err.Number & ") SQL_ISSUED: INSERT"
						Err.Clear
						GenerateError errorMsg, "insert"
						sqlError = True
						Exit For
					End If
					On Error Goto 0
				End If
			Next

			If Not sqlError Then
				On Error Resume Next
				objRS.Update
				If Err.Number <> 0 Then
					errorMsg = "" & Err.Description & " (" & Err.Number & ") SQL_ISSUED: INSERT"
					Err.Clear
					GenerateError errorMsg, "insert"
					sqlError = True
				End If
				On Error Goto 0

				If Not sqlError Then
					On Error Resume Next
					newId = objRS.Fields(kname)
					If Err.Number <> 0 Then
						errorMsg = "" & Err.Description & " (" & Err.Number & ") SQL_ISSUED: INSERT"
						Err.Clear
						GenerateError errorMsg, "insert"
						sqlError = True
					Else
						' -- append result doc for newId --
						Set roperationNode = resultdoc.createElement("operation")
						roperationNode.setAttribute "op", "update"
						roperationNode.setAttribute "id", operationId

						Set rfieldNode = resultdoc.createElement("field")
						rfieldNode.setAttribute "name", kname
						rfieldNode.setAttribute "curValue", newId

						roperationNode.appendChild(rfieldNode)
						resultRootNode.appendChild(roperationNode)
					End If
				End If
			End If

			objRS.Close
			Set objRS = Nothing

		End If
	Next


	' Send XML to Response
   	resultdoc.save(Response)

	objConn.Close
   	Set objConn = Nothing

  	Set xmldoc=Nothing
  	Set resultdoc=Nothing

%>

<SCRIPT LANGUAGE=VBScript RUNAT=Server>
Function GenerateError(msg, operationType)
	Set roperationNode = resultdoc.createElement("operation")
	roperationNode.setAttribute "op", operationType
	roperationNode.setAttribute "id", operationId
	roperationNode.setAttribute "msg", msg

	resultRootNode.appendChild(roperationNode)
End Function

Function CheckBooleanValue(val)
	Dim bValue, value
	bValue = False
	value = UCase(val)
	If value = "1" Or value = "YES" Or value = "Y" Or value= "TRUE" Or value = "T" Then
		bValue = True
	ElseIf value = "VRAI" Or value = "OUI" Or value = "O" Then
		bValue = True
	End If
	CheckBooleanValue = bValue
End Function


</SCRIPT>
