<%@LANGUAGE="VBSCRIPT" CodePage=65001%>
<% option explicit %>
<!--METADATA TYPE="typelib" uuid="00000206-0000-0010-8000-00AA006D2EA4" -->
<!--#include file="connection.inc" -->
<%

	' ----- No Cache -----
	Response.Expires = -1

	Function FormatValue(val, ftype)
		' Boolean
		If ftype = adBoolean Then
			If val Then
				FormatValue = "Yes"
			Else
				FormatValue = "No"
			End If
			Exit Function
		End If

		If ftype = adDate Or ftype = adDBDate Or ftype = adDBTimestamp Then
			' Convert to iso Date YYYY-MM-DD
			Dim dteDay, dteMonth, dteYear
			dteDay = Day(val)
			dteMonth = Month(val)
			dteYear   = Year(val)
			FormatValue = dteYear & "-" & Right(Cstr(dteMonth + 100),2) & "-" & Right(Cstr(dteDay + 100),2)
			Exit Function
		End If


		If IsNull(val) Or val = "" Then
			FormatValue = ""
		Else
			FormatValue = val
		End If
	End Function

	' ----- DB Connection -----
	' use DB_connection declared in connection.inc

	Dim objConn
	Set objConn = Server.CreateObject("ADODB.Connection")
	objConn.Open DB_connection

  	Dim xmldoc
  	Set xmldoc = Server.CreateObject("Microsoft.XMLDOM")
  	xmldoc.async = False
    xmldoc.loadXML( "<?xml version=""1.0"" encoding=""UTF-8"" ?><datapacket></datapacket>")

	Dim mainNode
	Set mainNode = xmldoc.createElement("datapacket")
	Set xmldoc.documentElement = mainNode


	' ----- SQL Request -----
	Dim strSQL, objRS

	strSQL="select * from TimeEntry"

	Set objRS = Server.CreateObject("ADODB.RecordSet")
	objRS.cursorLocation=adUseClient
	objRS.cachesize=100
	objRS.Open strSQL, objConn, adOpenStatic

	Dim howManyFields
	howManyFields = objRS.Fields.Count

	Dim i
	Dim aNode, fname, fvalue, ftype
	Do While Not objRS.EOF

		Set aNode = xmldoc.createElement("row")

		For i  = 0 To howManyFields-1
			fname = UCase(objRS.Fields(i).Name)
			fvalue = objRS.Fields(i).Value
			ftype = objRS.Fields(i).Type

			aNode.setAttribute fname, FormatValue(fvalue, ftype)
		Next

		mainNode.appendChild(aNode)
		objRS.MoveNext
	Loop


	' Send XML  to Response
   	xmldoc.save(Response)

	objConn.Close
   	Set objConn = Nothing

  	Set xmldoc=Nothing

%>
